<template>
  <q-page class="flex flex-center">
    <div class="row full-height" v-if="step === 0">
      <!-- Block 1 -->
      <div class="offset-2 col-10  col-md-4">
        <q-list>
          <q-item>
            <q-item-section>
              <q-item-label
                ><h4 class="text-terciary">
                  Persones & Projectes
                </h4>
              </q-item-label>
            </q-item-section>
          </q-item>
          <q-item>
            <q-item-section>
              <p>
                Masies x Viure és una plataforma digital que enxarxa persones
                afins amb projectes compatibles i els connecta amb professionals
                i recursos per crear projectes col·lectius als món rurals.
              </p>
            </q-item-section>
          </q-item>
          <q-item class="column">
            <q-list bordered separator>
              <q-item clickable v-ripple @click="setProfileType('uc')">
                <q-item-section avatar>
                  <q-avatar
                    color="primary"
                    text-color="white"
                    icon="family_restroom"
                  />
                </q-item-section>

                <q-item-section>
                  <q-item-label>Unitat de Convivència (UC)</q-item-label>
                  <q-item-label caption lines="3">
                    Les UC's podran fer un perfil i ajuntar-se amb altres U.C’s
                    per a crear Projectes comuns.
                  </q-item-label>
                </q-item-section>

                <q-item-section side>
                  <q-icon name="chevron_right" color="yellow" />
                </q-item-section>
              </q-item>
            </q-list>
            <br />
            <q-list bordered separator>
              <q-item clickable v-ripple @click="setProfileType('project')">
                <q-item-section avatar>
                  <q-avatar color="primary" text-color="white" icon="groups" />
                </q-item-section>

                <q-item-section>
                  <q-item-label>Projectes (Grups)</q-item-label>
                  <q-item-label caption lines="3">
                    Perfil per a grups que tenen un projecte en comú.
                  </q-item-label>
                </q-item-section>

                <q-item-section side>
                  <q-icon name="chevron_right" color="yellow" />
                </q-item-section>
              </q-item>
            </q-list>
          </q-item>
        </q-list>
      </div>
      <!-- Block 2 -->
      <div
        class="col-12 column flex-center offset-md-1 overflow-hidden col-md-3 bg-img-mur-masia relative-position"
      >
        <!-- Default -->
        <div
          v-if="profile.profileType === null"
          :class="
            Screen.lt.md ? 'relative-bottom-right' : 'absolute-bottom-right'
          "
          class="text-subtitle2"
        >
          <p class="q-pa-lg q-ml-xl q-my-xl bg-white block">
            {{ sentence }}
          </p>
        </div>
        <!-- Profile Type -->
        <q-list v-else class="bg-secondary">
          <q-item class="no-padding">
            <q-item-section class="flex-center">
              <q-img
                fit="fill"
                loading="lazy"
                alt="Masies x Viure - www.masiesxviure.cat"
                :src="CONTENT[profile.profileType].imgSrc"
                height="150"
                spinner-color="primary"
                spinner-size="82px"
              />
            </q-item-section>
          </q-item>
          <q-item>
            <q-item-section>
              <q-item-label class="text-center text-terciary">
                <h4>{{ CONTENT[profile.profileType].title }}</h4>
              </q-item-label>
            </q-item-section>
          </q-item>
          <q-item class="q-px-lg">
            <q-item-section>
              <p>{{ CONTENT[profile.profileType].body[0] }}</p>
              <p>{{ CONTENT[profile.profileType].body[1] }}</p>
            </q-item-section>
          </q-item>
          <q-item class="q-pb-lg">
            <q-item-section class="items-center">
              <q-btn
                unelevated
                color="primary"
                icon-right="chevron_right"
                label="Següent"
                style="width:250px"
                @click="step++"
              />
            </q-item-section>
          </q-item>
        </q-list>
      </div>
    </div>

    <!-- QUESTIONS -->

    <div v-else-if="step !== 0" class="q-pa-md full-width row flex-center">
      <q-card flat bordered square class="col-12 row">
        <component :is="formStep[profile.profileType][step]"></component>
        <q-separator />

        <q-card-actions align="center" class="col-12">
          <q-btn
            flat
            square
            color="primary"
            icon="chevron_left"
            label="Enrera"
            @click="step--"
          />
          <q-btn
            :disable="!actionsConfig[profile.profileType](step)"
            unelevated
            square
            color="green"
            icon-right="chevron_right"
            label="Següent"
            @click="step++"
          />
        </q-card-actions>
      </q-card>
    </div>
  </q-page>
</template>

<script setup>
import { Screen } from 'quasar'
import { ProfileStore } from 'stores/profileStore'
import SENTENCES from '../i18n/ca/sentences.js'
import { defineAsyncComponent, ref } from 'vue'
import { useRouter } from 'vue-router'

import UcType from 'src/components/LandingProfile/UcType.vue'
import Members from 'src/components/LandingProfile/Members.vue'
import Description from 'src/components/LandingProfile/Description.vue'
import WhereTo from 'src/components/LandingProfile/WhereTo.vue'
import Credentials from 'src/components/LandingProfile/Credentials.vue'
const ProjectType = defineAsyncComponent(() =>
  import('src/components/LandingProfile/ProjectType.vue')
)
const router = useRouter()
const profile = ProfileStore()
const sentence = SENTENCES[Math.floor(Math.random() * SENTENCES.length)]
const setProfileType = type => {
  profile.profileType = type
}
const step = ref(0)

const goHome = () => {
  router.push({ name: 'home' })
}

// Config for steps
const formStep = {
  uc: [
    null,
    UcType,
    Members,
    Description,
    WhereTo,
    Credentials,
    () => goHome()
  ],
  project: [
    null,
    ProjectType,
    Members,
    Description,
    WhereTo,
    Credentials,
    () => goHome()
  ]
}
// Config to enable Next button
const actionsConfig = {
  uc: step => {
    switch (step) {
      case 1:
        return profile.stage !== null
      case 2:
        return profile.members.length > 0
      case 3:
        return profile.descriptionShort?.length > 0
      case 4:
        return profile.locations.length > 0
      case 5:
        return (
          profile.credentials.email?.length > 0 &&
          profile.credentials.pwd?.length > 0
        )
      default:
        return true
    }
  },
  project: step => {
    switch (step) {
      case 1:
        return profile.stage !== null
      case 2:
        return profile.members.length > 0
      case 3:
        return profile.descriptionShort?.length > 0
      case 4:
        return profile.locations.length > 0
      case 5:
        return (
          profile.credentials.email?.length > 0 &&
          profile.credentials.pwd?.length > 0
        )
      default:
        return true
    }
  }
}

const CONTENT = {
  uc: {
    title: 'Unitat de Convivència',
    imgSrc:
      'https://res.cloudinary.com/mxv-cloud/image/upload/c_scale,h_300/v1648678026/App/Persones%20i%20Projectes/UC_-_Fami%CC%81lia_qmbkdz.jpg',
    body: [
      'Perfil per a una Persona, Família, Parella, etc que es consideri Unitat de Convivència.',
      `Un perfil UC pot incorporar-se a diferents Perfils de Projectes:
      Sovint un projecte té baixes d’Unitats de convivència, o simplement
      una UC està coneguent diferents projectes i
      més tard s’acaba decidint per un o l’altre.`
    ]
  },
  project: {
    title: 'Projecte',
    imgSrc:
      'https://res.cloudinary.com/mxv-cloud/image/upload/v1648678008/App/Persones%20i%20Projectes/Grup_-_projecte_frqh7x.jpg',
    body: [
      `Perfil per a grups que tenen un projecte en comú. El grup està
      conformat per diferents UC’s i tenen uns objectius comuns que es
      vehiculen en un projecte col·lectiu.`,
      `Un perfil de Projecte permet incorporar nous UC’s més endavant:
      El grup llavor pot autodefinir-se com a projecte per començar a
      desenvolupar-lo, i més endavant, incorporar nous UC’s per
      assolir les necessitats del projecte.`
    ]
  }
}
</script>

<style lang="sass">
.bg-img-mur-masia
  background-image: url('https://res.cloudinary.com/mxv-cloud/image/upload/v1648077356/App/Persones%20i%20Projectes/Mur_Porta_Finstres_Flors_d_una_Masia_gmrqo7.jpg')
</style>
